import xml.dom.minidom
import numpy as np
from skimage import io
from mayavi import mlab

# 将TexGen生成的模型转换为图片
# 注意像素尺寸

nx, ny, nz = 50, 50, 20  # number of cells in each direction

# load the unstructed grid (voxel model from TexGen with extension of .vtu)
domtree = xml.dom.minidom.parse('C:/Users/palme/Desktop/111.vtu')
rootNode = domtree.documentElement
UnstructuredGrid = rootNode.getElementsByTagName('UnstructuredGrid')

Piece = UnstructuredGrid[0].getElementsByTagName('Piece')
childlist = Piece[0].childNodes

CellData = Piece[0].getElementsByTagName('CellData')
DataArray = CellData[0].getElementsByTagName('DataArray')

###################################################
# Add grayscale as mask (field data assigned to each cell)
##io.use_plugin('pil') 
##ic = io.imread_collection(
##        'D:/04_coding/Python/06_Visualization/Mesh/00_data_acquisition/3D_2_4_5layers/Long_0/Long_0_img/*.tif') # <class 'skimage.io.collection.ImageCollection'>
####io.imshow_collection(ic)
####io.show()
##image_3d = io.concatenate_images(ic) # <class 'numpy.ndarray'>

#3mlab.contour3d(image_3d[:,70:130,45:130])
#mlab.outline()
#np.save('./greylevel.npy',image_3d[:,70:130,45:130])


def np2str(np_arr):
        np_arr = np_arr.reshape(1,-1)[0]
        str_arr = ""
        for i in np_arr:
                str_arr += str(i)+" "
        return str_arr

#交换数组的轴至：shape(z,y,x)
image_3d = np.swapaxes(image_3d, 0,1)
image_3d = np.swapaxes(image_3d, 1,2)

imgId= domtree.createElement('DataArray')
# 切片时一定要注意多余数据不影响显示，故ParaView不会报错
imgId.appendChild(domtree.createTextNode(np2str(image_3d[:, :, 0:704:4])))
imgId.setAttribute('Name','image_3d')
imgId.setAttribute('NumberOfComponents','1')
imgId.setAttribute('format','ascii')
imgId.setAttribute('type','Float64')
CellData[0].appendChild(imgId)

# update DataArray
DataArray = CellData[0].getElementsByTagName('DataArray')
# Save vtu as image sequence
for item in DataArray:
        if item.getAttribute('Name') == "YarnIndex":
                YarnIndex = item.childNodes[0].data
                YarnIndex=YarnIndex.split(" ")
                img_sequence = np.empty([nz, nx,ny])
                for i in range(nz):
                        start = i*nx*ny
                        end = (i+1)*nx*ny
                        img = np.array(YarnIndex[start:end], dtype = float).reshape([nx,ny])
                        img_sequence[i,:,:]  = img 
                        io.imsave("C:/Users/palme/Desktop/img/" + str(i)+'.jpeg', img)

# Delete unnecessary cell data
for item in DataArray:
        if item.getAttribute('Name') in ["SurfaceDistance", "Location", "YarnTangent", "Orientation"]:
                CellData[0].removeChild(item)



# write out the xml file.
domtree.writexml(open("C:/Users/palme/Desktop/result.vtu","w"))
### Write the result to a vtu file
##with open("C:/Users/palme/Desktop/result.vtu","w") as fs:
##    fs.write(domtree.toxml())
##    fs.close()
